Bug 1731111 - Review Request: osbuild - A build system for OS images
Summary: Review Request: osbuild - A build system for OS images
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Patrik Kopkan
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-07-18 10:19 UTC by Martin Sehnoutka
Modified: 2019-10-29 14:15 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-10-29 14:15:36 UTC
pkopkan: fedora-review+


Attachments (Terms of Use)

Description Martin Sehnoutka 2019-07-18 10:19:21 UTC
Spec URL: 
https://github.com/larskarlitski/osbuild/blob/22313fbbb592780e079fea0e13e9ffc43001b078/osbuild.spec

SRPM URL: (currently fails to build due to some SSL error)
https://copr.fedorainfracloud.org/coprs/msehnout/osbuild/

Description: A build system for OS images intended for usage in lorax-composer.
Fedora Account System Username: msehnout

You can find more information about the package on Github:
https://github.com/larskarlitski/osbuild

The pull-request that introduces the spec file lives here:
https://github.com/larskarlitski/osbuild/pull/23/files

You can also build the package yourself:
$ make rpm

I recommend testing in VM as osbuild needs to run as root.

Comment 1 Patrik Kopkan 2019-07-18 16:20:32 UTC
> %description
> FIXME: Can this be synced with setup.py?

Unfortunately, You cannot change %description at %build etc. If you mean copy it from setup.py. Yes, that's fine.

You need to add license file somewhere

change:
%license  -> %license LICENSE
%doc -> %doc README.md


Also it would be good to have downloadable source and version matching release in github repo.
So if you do release you get easily both.

Otherwise version should be done this way https://docs.fedoraproject.org/en-US/packaging-guidelines/Versioning/#_snapshots
and the would look like this https://docs.fedoraproject.org/en-US/packaging-guidelines/SourceURL/#_commit_revision


%global commit b218430bfa0f78b8ae07d9303028df4d24ad8b6f
%global shortcommit %(c=%{commit}; echo ${c:0:7})

Source0:  https://github.com/larskarlitski/osbuild/archive/%{commit}/%{name}-%{shortcommit}.tar.gz
expanded:
Source: https://github.com/larskarlitski/osbuild/archive/b218430bfa0f78b8ae07d9303028df4d24ad8b6f/osbuild-b218430.tar.gz

Comment 2 Martin Sehnoutka 2019-07-19 13:31:32 UTC
(In reply to Patrik Kopkan from comment #1)
> 
> You need to add license file somewhere
> 
> change:
> %license  -> %license LICENSE
> %doc -> %doc README.md
> 

ok

> 
> Also it would be good to have downloadable source and version matching
> release in github repo.
> So if you do release you get easily both.
> 
> Otherwise version should be done this way
> https://docs.fedoraproject.org/en-US/packaging-guidelines/Versioning/
> #_snapshots
> and the would look like this
> https://docs.fedoraproject.org/en-US/packaging-guidelines/SourceURL/
> #_commit_revision
> 
> 
> %global commit b218430bfa0f78b8ae07d9303028df4d24ad8b6f
> %global shortcommit %(c=%{commit}; echo ${c:0:7})
> 
> Source0: 
> https://github.com/larskarlitski/osbuild/archive/%{commit}/%{name}-
> %{shortcommit}.tar.gz
> expanded:
> Source:
> https://github.com/larskarlitski/osbuild/archive/
> b218430bfa0f78b8ae07d9303028df4d24ad8b6f/osbuild-b218430.tar.gz

yes, this is something to decide, but we'd like to use packit for this package, so this might be related

what about this line?
> %{?python_provide:%python_provide python3-%{pypi_name}}

is it ok? because the package's name isn't python3-osbuild

Comment 3 Petr Viktorin 2019-07-22 08:23:10 UTC
> what about this line?
>> %{?python_provide:%python_provide python3-%{pypi_name}}

Most likely, you want to remove it.


If you want *people* to `dnf install python3-osbuild` rather than `dnf install osbuild`, you should add both of:

    Provides: python3-%{pypi_name}
    %{?python_provide:%python_provide python3-%{pypi_name}}

Comment 4 Martin Sehnoutka 2019-07-22 11:25:46 UTC
I decided to split the package into `osbuild` and `python3-osbuild`. The latest build is here:
https://copr-be.cloud.fedoraproject.org/results/msehnout/osbuild/fedora-30-x86_64/00976217-osbuild/

Comment 5 Patrik Kopkan 2019-07-22 14:46:34 UTC
If the files in osbuild package needs to have executables, move them to %{_libexecdir}. There is also issue that package does not own usr/lib/osbuild. %{_libexecdir}/%{pypi_name} should fix that.

Please add -p flag to install

Maybe osbuild should require python3-{%pypi-name} = %{version}-{release}

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
- Permissions on files are set properly.
  Note: See rpmlint output
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/#_file_permissions


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "*No copyright* Apache License (v2.0)".
     36 files have unknown license. Detailed output of licensecheck in
     /home/pkopkan/Documents/review/osbuild/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib/osbuild
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/osbuild
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[?]: Package uses nothing in %doc for runtime.
[!]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in osbuild
     , python3-osbuild
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[!]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: osbuild-1-1.fc31.noarch.rpm
          python3-osbuild-1-1.fc31.noarch.rpm
          osbuild-1-1.fc31.src.rpm
osbuild.noarch: W: only-non-binary-in-usr-lib
osbuild.noarch: W: no-documentation
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/assemblers/io.weldr.qcow2 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/assemblers/io.weldr.tar 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/osbuild-run 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.anaconda 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.ansible 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.dnf 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.grub2 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.locale 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.noop 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.remove-uniqueness 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.script 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.selinux 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.systemd 775
osbuild.noarch: W: no-manual-page-for-binary osbuild
osbuild.src:49: E: hardcoded-library-path in %{_prefix}/lib/osbuild/stages
osbuild.src:50: E: hardcoded-library-path in %{_prefix}/lib/osbuild/stages/
osbuild.src:51: E: hardcoded-library-path in %{_prefix}/lib/osbuild/assemblers
osbuild.src:52: E: hardcoded-library-path in %{_prefix}/lib/osbuild/assemblers/
osbuild.src:53: E: hardcoded-library-path in %{_prefix}/lib/osbuild/
osbuild.src:58: E: hardcoded-library-path in %{_prefix}/lib/osbuild/assemblers/
osbuild.src:59: E: hardcoded-library-path in %{_prefix}/lib/osbuild/osbuild-run
osbuild.src:60: E: hardcoded-library-path in %{_prefix}/lib/osbuild/stages/
osbuild.src: W: invalid-url Source0: osbuild-1.tar.gz
3 packages and 0 specfiles checked; 21 errors, 4 warnings.




Rpmlint (installed packages)
----------------------------
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "en_US.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "en_US.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
osbuild.noarch: W: invalid-url URL: https://github.com/larskarlitski/osbuild <urlopen error [Errno -2] Name or service not known>
osbuild.noarch: W: only-non-binary-in-usr-lib
osbuild.noarch: W: no-documentation
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/assemblers/io.weldr.qcow2 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/assemblers/io.weldr.tar 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/osbuild-run 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.anaconda 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.ansible 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.dnf 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.grub2 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.locale 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.noop 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.remove-uniqueness 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.script 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.selinux 775
osbuild.noarch: E: non-standard-executable-perm /usr/lib/osbuild/stages/io.weldr.systemd 775
osbuild.noarch: W: no-manual-page-for-binary osbuild
python3-osbuild.noarch: W: invalid-url URL: https://github.com/larskarlitski/osbuild <urlopen error [Errno -2] Name or service not known>
2 packages and 0 specfiles checked; 13 errors, 5 warnings.



Requires
--------
osbuild (rpmlib, GLIBC filtered):
    /usr/bin/python3
    bash
    coreutils
    dnf
    e2fsprogs
    glibc
    policycoreutils
    python3-osbuild
    qemu-img
    systemd
    systemd-container
    tar
    util-linux

python3-osbuild (rpmlib, GLIBC filtered):
    python(abi)
    python3.7dist(setuptools)



Provides
--------
osbuild:
    osbuild

python3-osbuild:
    python-osbuild
    python3-osbuild
    python3.7dist(osbuild)
    python3dist(osbuild)



Generated by fedora-review 0.7.2 (65d36bb) last change: 2019-04-09
Command line :/usr/bin/fedora-review -rn osbuild-1-1.fc30.src.rpm
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, Generic, Python
Disabled plugins: Haskell, PHP, R, Perl, Ocaml, Java, fonts, C/C++, SugarActivity
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 6 Martin Sehnoutka 2019-07-23 13:18:52 UTC
New build with corrections for the error listed above:
https://copr-be.cloud.fedoraproject.org/results/msehnout/osbuild/fedora-30-x86_64/00976739-osbuild/

Comment 7 Patrik Kopkan 2019-07-24 13:04:29 UTC
Good job, there is still one issue. The source is not downloadable because you don't have git tag/release in github.

Comment 8 Martin Sehnoutka 2019-07-26 07:59:41 UTC
Version 1 has just been released.

$ rpmdev-wipetree
$ spectool -C ~/rpmbuild/SOURCES -g osbuild.spec
$ rpmbuild -ba osbuild.spec

all went just fine. So I hope it is ready to be released.

Comment 9 Patrik Kopkan 2019-07-26 13:19:16 UTC
Indeed it is.

Comment 10 Gwyn Ciesla 2019-07-30 12:53:57 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/osbuild

Comment 11 Petr Viktorin 2019-10-29 14:15:36 UTC
The package has been built in Fedora. Closing.


Note You need to log in before you can comment on or make changes to this bug.